module Grid
  class CommandHandler
    def register_command(name, &block)
      @handlers ||= {}
      @handlers[name] = block
    end

    def on_command(command)
      @handlers[command.name].call(command.params)
    end
  end
end