require 'json'
require 'grid/zmq/socket'

module Grid
  module ZMQ
    class Client < Socket
      def initialize(address)
        super(::ZMQ::PUB)

        send(:bind, address)
      end

      def call(name, params)
        send(:send_string, Command.new(name, params).encode)
      end
    end
  end
end