require 'ffi-rzmq'
require 'grid/zmq/socket'
require 'grid/command'

module Grid
  module ZMQ
    class Stdin < Socket
      def initialize
        super(::ZMQ::SUB)

        send(:setsockopt, ::ZMQ::SUBSCRIBE, '')
      end

      def listen(address)
        send(:connect, address)

        loop do
          send(:recv_string, body = '')
          yield Command.parse(body)
        end
      end
    end
  end
end