module Grid
  class FakeStdin
    def listen(address, &block)
      @block = block
    end

    def send(name, params)
      command = Command.new(
        name, params
      )
      
      @block.call(command)
    end
  end
end